NotePost App
============

This is a client app for NotePost.  It has some offline capabilities and can be
built for most platforms by using [Apache Cordova](https://cordova.apache.org)
for mobile devices or [NW.js](https://nwjs.io) for PCs.

[Get prebuilt binaries here](https://build.netsyms.net/job/NotePostApp/)

Platform Support
----------------

Tested and should work on:
* Android 5+ (up-to-date WebView implementation required)
* Linux (amd64 and i386)

Not tested but should work on:
* Raspberry Pi (using a custom build of NW.js like
  [this one](https://github.com/LeonardLaszlo/nw.js-armv7-binaries))
* Windows
* MacOS (we don't currently offer Mac builds, see below)

There are no official builds for Mac for a few reasons: we don't own any Mac
computers; Mac builds are about 4x the size of the other builds; and the best
Mac build we could get working on a Linux build server was a ZIP file.  If you
want official Mac builds, you'll need to write a working Jenkins build script.

If you want an iOS build, donate $100 for an Apple Developer account.  The
framework this app uses has an iOS stylesheet, so it'll even look native.


Building for NW.js
------------------

Since this is a webapp, there isn't really a build process.

1. Install [Yarn](https://yarnpkg.com), and run `./yarninstall.sh` to grab dependencies.
2. Get [NW.js](https://nwjs.io) and unpack it into a folder (we'll use `~/nw.js`).
3. Move to the `www` folder in this repository and run `~/nw.js/nw .`
4. The process is basically the same for non-Linux systems, just use the appropriate
version of NW.js.


Building for Cordova/Android
----------------------------

This assumes you have Cordova and a working Android SDK installed.

1. Install [Yarn](https://yarnpkg.com), and run `./yarninstall.sh` to grab dependencies.
2. Run `./removebloat.sh` to cut the APK size in half.
3. Run `cordova platform add android`.
4. Run `cordova build android --release`.


License
-------

The code in `www` (except `node_modules`) is licensed under the Mozilla Public
License 2.0.  We didn't write the rest, most of it is autogenerated or third-party.
Consult `licenses.txt` or the built-in open source info page for details.

If you're making custom builds and distributing them, you need to [contact us](https://netsyms.com/contact) and
get permission to use the app name ("NotePost") and icon (`logo.png` and the files in `/res`).
If you're not customizing anything but simply building the app, you don't need permission,
but we would love if you contact us and let us know.