/*
 * This Source Code Form is subject to the terms of the Mozilla Public
 * License, v. 2.0. If a copy of the MPL was not distributed with this
 * file, You can obtain one at http://mozilla.org/MPL/2.0/.
 */


class NotePostAPI {
    constructor(server, username, password) {
        this.server = server;
        this.username = username;
        this.password = password;
    }

    post(action, data, success, error) {
        var self = this;
        return $.ajax({
            url: this.server + "/api/" + action,
            dataType: "json",
            method: "POST",
            data: data,
            beforeSend: function (xhr) {
                xhr.setRequestHeader("Authorization", "Basic " + btoa(self.username + ":" + self.password));
            },
            success: function (val) {
                if (typeof success == 'function') {
                    success(val);
                }
            },
            error: function () {
                if (typeof error == 'function') {
                    error();
                }
            }
        });
    }
}